/* Sistemas Integrados TEKNISA

Nome: 520E_DFSSTPS_GERA_NOTAFISCAL_PRODUTO.SQL

Descrio:
PROCEDIMENTOS PARA GERAO DE NOTAS FISCAIS PRODUTO

Criao:
05/10/2005 - Fabrcio Marcelo da Silva

*/

IF EXISTS (SELECT
              *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
	           O.NAME = 'GERA_NOTAFISCAL_PRODUTO' AND
	           TYPE = 'P' 			  AND
              U.UID = O.UID        AND
              U.NAME = USER)

DROP PROCEDURE GERA_NOTAFISCAL_PRODUTO
GO

CREATE PROCEDURE GERA_NOTAFISCAL_PRODUTO
   @P_CDFILIAL          VARCHAR(04),
   @P_NRLANCTONF        VARCHAR(10),
   @P_CDPRODUTO         VARCHAR(10),
   @P_CDPRODEMIS        VARCHAR(20),
   @P_DSPRODEMIS        TEXT,
   @P_QTITEMPROD        DOUBLE PRECISION,
   @P_VRUNITITEM        DOUBLE PRECISION,
   @P_VRDESCITEM        DOUBLE PRECISION       = 0,
   @P_CDFILIALITG       VARCHAR(04)            = NULL,
   @P_NRINTEGRACAO      VARCHAR(10)            = NULL,
   @P_NRITEMINTEGR      VARCHAR(10)            = NULL,
   @P_CDCSTINFUSU       VARCHAR(03)            = NULL,
   @P_CDCFOPINFUSU      VARCHAR(11)            = NULL,
   @P_CDSUFXINFUSU      VARCHAR(03)            = NULL,
   @P_CDALMOXARIFE      VARCHAR(06)            = NULL,
   @P_CDLOCALESTOQ      VARCHAR(06)            = NULL,
   @P_NRLOTEESTQ        VARCHAR(20)            = NULL,
   @P_NRSUBLOTE         VARCHAR(04)            = NULL,
   @P_IDCONFORITEM      VARCHAR(01)            = 'S',
   @P_IDTPNFCREDEB      VARCHAR(01)            = NULL,
   @P_QTVOLUITEM        DOUBLE PRECISION       = 0,
   @P_CDSERVFILI        VARCHAR(05)            = NULL,
   @P_CDFILIAPUR        VARCHAR(04)            = NULL,
   @P_CDMARCA           VARCHAR(05)            = NULL,
   @P_CDSERVFATU        VARCHAR(10)            = NULL,
   @P_IDORIGEMPROD      VARCHAR(01)            = 'N',
   @P_IDATUESTPROD      VARCHAR(01)            = 'S',
   @P_VRICMSSTITORIG    DOUBLE PRECISION       = 0
AS
   DECLARE @V_NRSEQITPROD  VARCHAR(04);
   DECLARE @V_IDCNTRESTOQ  VARCHAR(01);
   DECLARE @V_VRTOTAITEM   DOUBLE PRECISION;
   DECLARE @V_VRCONTITEM   DOUBLE PRECISION;
   DECLARE @V_VRDESPERITEM DOUBLE PRECISION;
   DECLARE @V_VRUNITITEM   DOUBLE PRECISION;
   DECLARE @V_VRTAXASTRIB  DOUBLE PRECISION;

   DECLARE @V_CDALMOXARIFE VARCHAR(06);
   DECLARE @V_CDLOCALESTOQ VARCHAR(06);
   DECLARE @V_IDUTILALMOX  VARCHAR(01);
   DECLARE @V_IDUTILLCESTQ VARCHAR(01);
   DECLARE @V_IDUTILLOTE   VARCHAR(01);

   DECLARE @V_IDENTRSAIDOP VARCHAR(01);
   DECLARE @V_CDFILIEMIT   VARCHAR(04);
   DECLARE @V_CDFILIRECE   VARCHAR(04);
   DECLARE @V_CDFILIMOVI   VARCHAR(04);
   DECLARE @V_NRLOTEESTQ   VARCHAR(20);
   DECLARE @V_NRSUBLOTE    VARCHAR(04);

   DECLARE @V_QTITEMPROD   DOUBLE PRECISION;
   DECLARE @V_QTSALDSAID   DOUBLE PRECISION;

   DECLARE @V_IDSISTEMA    VARCHAR(03);

   DECLARE @V_CDFILIALPED  VARCHAR(04);
   DECLARE @V_NRPEDIDO     VARCHAR(10);
   DECLARE @V_NRITEMPED    VARCHAR(10);

   DECLARE @V_CDFILIALPDV  VARCHAR(04);
   DECLARE @V_NRSEQVENDA   VARCHAR(10);
   DECLARE @V_NRSEQUITVEND VARCHAR(03);

   DECLARE @V_CDARVPROD    VARCHAR(20);
   DECLARE @V_CDEMPRESA    VARCHAR(02);
   DECLARE @V_CDINSCESTA   VARCHAR(16);
   DECLARE @V_CDTIPOOPER   VARCHAR(02);
   DECLARE @V_IDORIGDESTNF VARCHAR(01);
   DECLARE @V_CDCLIENTE    VARCHAR(21);
   DECLARE @V_CDGRUPOFISC  VARCHAR(03);
   DECLARE @V_DTENTRSAID   DATETIME;
   DECLARE @V_PAISORIG     VARCHAR(04);
   DECLARE @V_ESTAORIG     VARCHAR(02);
   DECLARE @V_PAISDEST     VARCHAR(04);
   DECLARE @V_ESTADEST     VARCHAR(02);
   DECLARE @V_MUNIORIG     VARCHAR(04);
   DECLARE @V_ALIQUTMP     DOUBLE PRECISION;
   DECLARE @V_TRATIMPST    VARCHAR(01);
   DECLARE @V_PBCSUBTRIB   DOUBLE PRECISION;

   DECLARE @V_VRDESCITEM   DOUBLE PRECISION;
   DECLARE @V_VRTOTPEDIDO  DOUBLE PRECISION;
   DECLARE @V_CDPRODESTO   VARCHAR(10);
   DECLARE @V_VRFATOCONV   DOUBLE PRECISION;
   DECLARE @V_VRTOTAL      DOUBLE PRECISION;

   DECLARE @V_NRORDEMCMPPED   VARCHAR(15);
   DECLARE @V_NRITORDEMCMPPED VARCHAR(6);
   DECLARE @V_DADOADIC        VARCHAR(3);
   DECLARE @V_DSDADOADIC        VARCHAR(225);

   DECLARE @V_IMPOSTRIB_CDIMPOTEMP   VARCHAR(02);

   DECLARE @V_LOTE_CDALMOXARIFE      VARCHAR(06);
   DECLARE @V_LOTE_CDLOCALESTOQ      VARCHAR(06); 
   DECLARE @V_LOTE_NRLOTEESTQ        VARCHAR(20);
   DECLARE @V_LOTE_NRSUBLOTE         VARCHAR(04);
   DECLARE @V_LOTE_QTTOTALESTOQ      DOUBLE PRECISION;
   DECLARE @V_LOTE_VRTOTALESTOQ      DOUBLE PRECISION;
   DECLARE @V_IDFUNCAOFILI           VARCHAR(01);
   DECLARE @V_CDTPOPERPERDA          VARCHAR(02);
   DECLARE @V_CDTPOPERSOBRA          VARCHAR(02);
   DECLARE @V_NRLOTEESTQORIG         VARCHAR(20);
   DECLARE @V_NRSUBLOTEORIG          VARCHAR(04);
   DECLARE @V_NOTAFORNECEDOR         VARCHAR(20);
   DECLARE @V_LOTEFORNECEDOR         VARCHAR(20);
   DECLARE @V_TEXTOADICEMIS          VARCHAR(100);
   DECLARE @V_IDINFLOTFOREMI         VARCHAR(01);
   DECLARE @V_NRLOTEDADOFOR          VARCHAR(20);
   DECLARE @V_NRSUBLOTEDADOFOR       VARCHAR(04);

   DECLARE @ARRAY_NRSEQITPROD TABLE (NRSEQITPROD VARCHAR(04));
   DECLARE @C_ARRAY_NRSEQITPROD_NRSEQITPROD VARCHAR(04);
   DECLARE @V_VRICMSSTITORIG         DOUBLE PRECISION;

   DECLARE @V_DTENTPED      DATE;
   DECLARE @V_CDFILLANCA    VARCHAR(04);
   DECLARE @V_CDFILSOLI     VARCHAR(04);
   DECLARE @V_NRSOLICMP     VARCHAR(10);
   DECLARE @V_NRSOLICMPINTG VARCHAR(06);
   DECLARE @V_NRITEMINTG    VARCHAR(04);
   DECLARE @V_IDESTGERALEXP VARCHAR(01);

BEGIN
   SET @V_NRSEQITPROD       = NULL;
   SET @V_IDENTRSAIDOP      = NULL;
   SET @V_CDFILIEMIT        = NULL;
   SET @V_CDFILIRECE        = NULL;
   SET @V_IDSISTEMA         = NULL;
   SET @V_CDEMPRESA         = NULL;
   SET @V_CDINSCESTA        = NULL;
   SET @V_CDTIPOOPER        = NULL;
   SET @V_IDORIGDESTNF      = NULL;
   SET @V_CDCLIENTE         = NULL;
   SET @V_DTENTRSAID        = NULL;
   SET @V_CDARVPROD         = NULL;
   SET @V_VRFATOCONV        = 0;
   SET @V_PAISORIG          = NULL;
   SET @V_ESTAORIG          = NULL;
   SET @V_PAISDEST          = NULL;
   SET @V_ESTADEST          = NULL;
   SET @V_MUNIORIG          = NULL;
   SET @V_ALIQUTMP          = 0;
   SET @V_TRATIMPST         = NULL;
   SET @V_PBCSUBTRIB        = 0;
   SET @V_IDCNTRESTOQ       = NULL;
   SET @V_CDALMOXARIFE      = NULL;
   SET @V_CDLOCALESTOQ      = NULL;
   SET @V_IDUTILALMOX       = NULL;
   SET @V_IDUTILLCESTQ      = NULL;
   SET @V_IDUTILLOTE        = NULL;
   SET @V_CDPRODESTO        = NULL;
   SET @V_IDFUNCAOFILI      = NULL;

   IF @P_NRINTEGRACAO IS NOT NULL BEGIN
      /* BUSCA O NMERO DA ORDEM DE COMPRA DE ACORDO COM O NMERO DO PEDIDO E DO ITEM */
      SELECT @V_NRORDEMCMPPED = MAX(P.NRORDEMCMPPED), @V_NRITORDEMCMPPED = MAX(I.NRITORDEMCMPPED), @V_DTENTPED = MAX(P.DTENTPED)
        FROM PEDIDO P, ITEMPEDIDO I
       WHERE P.CDFILIAL  = I.CDFILIAL
         AND P.NRPEDIDO  = I.NRPEDIDO
         AND P.CDFILIAL  = @P_CDFILIALITG
         AND P.NRPEDIDO  = @P_NRINTEGRACAO
         AND I.NRITEMPED = @P_NRITEMINTEGR;

      /*INTEGRACAO TEKNISA X MADERO*/
      /*SE O PEDIDO VEIO DE SC, E O ITEM TEM NRITEMINTG, SAO ESSAS INFORMACOES QUE VAO PARA A NOTA*/

      /*VERIFICA SE O PEDIDO VEIO DE SOLICITACAO DE COMPRAS*/
      SELECT @V_CDFILLANCA = MAX(CDFILLANCA), @V_CDFILSOLI = MAX(CDFILSOLI), @V_NRSOLICMPINTG = SUBSTRING(MAX(NRSOLICMP), 5, 6), @V_NRSOLICMP = MAX(NRSOLICMP)
        FROM PEDIDO
       WHERE CDFILIAL = @P_CDFILIALITG
         AND NRPEDIDO = @P_NRINTEGRACAO;

      /*BUSCA O NUMERO DE INTEGRACAO DO ITEM*/
      SELECT @V_NRITEMINTG = MAX(NRITEMINTG)
        FROM ITEMSOLI
       WHERE CDFILSOLI =  @V_CDFILSOLI
         AND CDFILLAN = @V_CDFILLANCA
         AND NRSOLICMP = @V_NRSOLICMP
         AND CDPRODUTO = @P_CDPRODUTO
         AND DTPROGENTR = @V_DTENTPED;

      IF @V_NRITEMINTG IS NOT NULL BEGIN
         SET @V_NRORDEMCMPPED   = @V_NRSOLICMPINTG;
         SET @V_NRITORDEMCMPPED = @V_NRITEMINTG;
      END;
   END
   ELSE BEGIN
      SET @V_NRORDEMCMPPED = '';

      SELECT @V_IDFUNCAOFILI = ISNULL(MAX(IDFUNCAOFILI), 'X')
        FROM FILIAL F, NOTAFISCAL N
       WHERE F.CDFILIAL = N.CDFILIEMIT
         AND N.CDFILIAL = @P_CDFILIAL
         AND N.NRLANCTONF = @P_NRLANCTONF
         AND N.IDENTRSAIDOP = 'S';

      IF @V_IDFUNCAOFILI = 'O' BEGIN
         SELECT @V_NRORDEMCMPPED = MAX(USR_NRPEDIDO)
           FROM NFRELACPEXOL R, PEDIDOEXOL P
          WHERE R.CDFILIAL = @P_CDFILIAL
            AND R.NRLANCTONF = @P_NRLANCTONF
            AND R.CDFILDEST = P.CDFILDEST
            AND R.CDFILLANC = P.CDFILLANC
            AND R.NRPEDEXOL = P.NRPEDEXOL;
      END;
   END;

   /*PREENCHE A MENSAGEM COM O NUMERO DA ORDEM DE COMPRA*/
   IF @V_NRORDEMCMPPED IS NOT NULL BEGIN

      /*MAIOR REGISTRO DA TABELA DE DADOS ADICIONAIS*/
      SELECT @V_DADOADIC = MAX(NRDADOADIC)
        FROM DADOSADIC
       WHERE (CDFILIAL   = @P_cdFILIAL)
         AND (NRLANCTONF = @P_NRLANCTONF);

      IF @V_DADOADIC IS NULL BEGIN
         SET @V_DADOADIC = '001';
      END;

      SET @V_DSDADOADIC =  'Nmero da Ordem do Pedido: '+ @V_NRORDEMCMPPED;
      INSERT INTO DADOSADIC
         (CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
      VALUES
         (@P_cdFILIAL, @P_NRLANCTONF, @V_DADOADIC, @V_DSDADOADIC);
   END;

   SELECT @V_NRSEQITPROD = RIGHT(REPLICATE('0',4)+ CONVERT(VARCHAR, (CONVERT(NUMERIC, ISNULL(MAX(NRSEQITPROD),'0000')) + 1)),4)
   FROM ITEMPRODUTO
   WHERE CDFILIAL   = @P_CDFILIAL AND
         NRLANCTONF = @P_NRLANCTONF;

   INSERT INTO @ARRAY_NRSEQITPROD VALUES (@V_NRSEQITPROD);

   SET @V_VRUNITITEM = @P_VRUNITITEM;

   SELECT @V_IDENTRSAIDOP = MAX(IDENTRSAIDOP), @V_CDFILIEMIT = MAX(CDFILIEMIT), @V_CDFILIRECE = MAX(CDFILIRECE), @V_IDSISTEMA = MAX(IDSISTEMA),
          @V_CDEMPRESA = MAX(CDEMPRESA), @V_CDINSCESTA = MAX(CDINSCESTA), @V_CDTIPOOPER = MAX(CDTIPOOPER), @V_IDORIGDESTNF = MAX(IDORIGDESTNF),
          @V_CDCLIENTE = MAX(CDCLIENTE), @V_DTENTRSAID = MAX(DTENTRSAID)
   FROM NOTAFISCAL
   WHERE CDFILIAL   = @P_CDFILIAL AND
         NRLANCTONF = @P_NRLANCTONF;

   IF (@V_IDENTRSAIDOP = 'S') BEGIN
      SET @V_CDFILIMOVI = @V_CDFILIEMIT;
   END
   ELSE BEGIN
      SET @V_CDFILIMOVI = @V_CDFILIRECE;
   END;

   SELECT @V_CDTPOPERPERDA = MAX(CDTPOPERPERDA),
          @V_CDTPOPERSOBRA = MAX(CDTPOPERSOBRA),
          @V_IDESTGERALEXP = ISNULL(MAX(IDESTGERALEXP), 'N')
     FROM PAREXPEDICAO
    WHERE CDFILIAL = @P_CDFILIAL;

   SELECT @V_CDARVPROD = MAX(CDARVPROD), @V_VRFATOCONV = MAX(VRFATOCONV)
   FROM PRODUTO
   WHERE CDPRODUTO = @P_CDPRODUTO;

   EXEC CONSULTA_GRUPOFISCAL @V_IDORIGDESTNF, @V_CDCLIENTE, '', 'S', @V_CDTIPOOPER, @V_CDGRUPOFISC;
   EXEC CONSULTA_INCIDENCIA 'S', @V_CDEMPRESA, @V_CDARVPROD, @V_CDINSCESTA, @V_CDTIPOOPER, @P_CDFILIAL, @P_NRLANCTONF, @V_CDGRUPOFISC,
                            NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, @P_IDORIGEMPROD;

   DECLARE C_IMPOSTRIB CURSOR FOR
      SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP
      FROM INCITEMP IT, IMPOSTO IP
      WHERE (IT.NRINCITEMP  = @P_CDFILIAL + @P_NRLANCTONF) AND
            (IT.CDIMPOTEMP  = IP.CDIMPOSTRIB);

   OPEN C_IMPOSTRIB;
   FETCH NEXT FROM C_IMPOSTRIB INTO @V_IMPOSTRIB_CDIMPOTEMP;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT @V_PAISORIG = MAX(CDPAISORIG), @V_ESTAORIG = MAX(SGESTAORIG), @V_PAISDEST = MAX(CDPAISDEST),
             @V_ESTADEST = MAX(SGESTADEST), @V_MUNIORIG = MAX(CDMUNIORIG)
      FROM ORIGDESTNF
      WHERE CDFILIAL   = @P_CDFILIAL AND
            NRLANCTONF = @P_NRLANCTONF;

      SET @V_VRTOTAL = (@P_QTITEMPROD * @P_VRUNITITEM);

      EXEC CONSULTA_ALIQUOTA @V_IMPOSTRIB_CDIMPOTEMP, 'S', @V_CDEMPRESA, @V_CDARVPROD, @V_CDINSCESTA,
                             @V_PAISORIG, @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_VRTOTAL,
                             @V_DTENTRSAID, @P_CDFILIAL, @P_NRLANCTONF, @V_CDGRUPOFISC,
                             NULL, NULL, NULL, NULL, NULL, NULL, NULL, @P_IDORIGEMPROD;

      SELECT @V_ALIQUTMP = ISNULL(MAX(VRALIQUTMP),0), @V_TRATIMPST = ISNULL(MAX(IDTRIMPSTTMP), '0'),
             @V_PBCSUBTRIB = ISNULL(MAX(VRPBCSTTMP),0)
      FROM ALIQTEMP
      WHERE (NRALIQTEMP = @P_CDFILIAL + @P_NRLANCTONF);

      IF @V_TRATIMPST = '1' BEGIN
         SET @V_VRTAXASTRIB = (1 + (@V_PBCSUBTRIB/100)) * (@V_ALIQUTMP/100);
         SET @V_VRUNITITEM  = (@V_VRUNITITEM / (1 - @V_VRTAXASTRIB));
      END;

      FETCH NEXT FROM C_IMPOSTRIB INTO @V_IMPOSTRIB_CDIMPOTEMP;
   END;
   CLOSE C_IMPOSTRIB;
   DEALLOCATE C_IMPOSTRIB;

   DELETE FROM INCITEMP
   WHERE NRINCITEMP  = @P_CDFILIAL + @P_NRLANCTONF;

   DELETE FROM ALIQTEMP
   WHERE NRALIQTEMP = @P_CDFILIAL + @P_NRLANCTONF;

   SET @V_VRTOTAITEM   = @V_VRUNITITEM * @P_QTITEMPROD;
   SET @V_VRCONTITEM   = @V_VRTOTAITEM - @P_VRDESCITEM;
   SET @V_VRTOTPEDIDO  = @V_VRTOTAITEM;
   IF @V_VRTOTAITEM > 0  BEGIN
      SET @V_VRDESPERITEM = ROUND((@P_VRDESCITEM * 100)/@V_VRTOTAITEM, 4);
   END
   ELSE BEGIN
      SET @V_VRDESPERITEM = 0;
   END;

   IF (NOT @V_IDSISTEMA IN('FAI','FAC','FAS')) BEGIN
      SELECT @V_IDCNTRESTOQ  = ISNULL(MAX(P.IDCNTRESTOQ),ISNULL(MAX(F.IDCTRLESTQ),'S')),
             @V_CDALMOXARIFE = ISNULL(ISNULL(MAX(P.CDALMOXARIFE),MAX(F.CDALMOXARIFE)),' '),
             @V_CDLOCALESTOQ = ISNULL(ISNULL(MAX(P.CDLOCALESTOQ),MAX(F.CDLOCALESTOQ)),' '),
             @V_IDUTILALMOX  = ISNULL(MAX(IDUTILALMOX),'N'),
             @V_IDUTILLCESTQ = ISNULL(MAX(IDUTILLCESTQ),'N'),
             @V_IDUTILLOTE   = ISNULL(MAX(IDUTILLOTE),'N')
      FROM PRODFILI P, PARAMFILIAL F, PRODUTO D
      WHERE P.CDFILIAL   = @V_CDFILIMOVI AND
            P.CDFILIAL   = F.CDFILIAL   AND
            D.CDPRODUTO  = @P_CDPRODUTO  AND
            P.CDPRODUTO  = D.CDPRODESTO AND
            (F.IDCTRLESTQ = 'S' OR F.IDCTRLESTQ IS NULL);

      IF (NOT @P_CDALMOXARIFE IS NULL) BEGIN
         SET @V_CDALMOXARIFE = @P_CDALMOXARIFE;
         IF (NOT @P_CDLOCALESTOQ IS NULL) BEGIN
            SET @V_CDLOCALESTOQ = @P_CDLOCALESTOQ;
         END
         ELSE BEGIN
            SET @V_CDLOCALESTOQ =  ' ';
         END;
      END
      ELSE BEGIN
         IF (@V_IDUTILALMOX = 'N') BEGIN
            SET @V_CDALMOXARIFE = ' ';
            SET @V_CDLOCALESTOQ = ' ';
         END
         ELSE IF (@V_CDLOCALESTOQ = 'N') BEGIN
            SET @V_CDLOCALESTOQ = ' ';
         END;
      END;

      IF (@V_IDSISTEMA = 'PDV') OR (@V_IDSISTEMA = 'VND') BEGIN
         SET @V_CDFILIALPED  = NULL;
         SET @V_NRPEDIDO     = NULL;
         SET @V_NRITEMPED    = NULL;
         SET @V_CDFILIALPDV  = @P_CDFILIALITG;
         SET @V_NRSEQVENDA   = @P_NRINTEGRACAO;
         SET @V_NRSEQUITVEND = @P_NRITEMINTEGR;
      END
      ELSE IF (@V_IDSISTEMA = 'PED') OR (@V_IDSISTEMA = 'EXP') OR (@V_IDSISTEMA = 'SEP') BEGIN
         SET @V_CDFILIALPED  = @P_CDFILIALITG;
         SET @V_NRPEDIDO     = @P_NRINTEGRACAO;
         SET @V_NRITEMPED    = @P_NRITEMINTEGR;
         SET @V_CDFILIALPDV  = NULL;
         SET @V_NRSEQVENDA   = NULL;
         SET @V_NRSEQUITVEND = NULL;
      END
      ELSE BEGIN
         SET @V_CDFILIALPED  = NULL;
         SET @V_NRPEDIDO     = NULL;
         SET @V_NRITEMPED    = NULL;
         SET @V_CDFILIALPDV  = NULL;
         SET @V_NRSEQVENDA   = NULL;
         SET @V_NRSEQUITVEND = NULL;
      END;

      IF @V_IDCNTRESTOQ = 'S' BEGIN
         INSERT INTO PRODLCESTOQ
         (CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO)
         (SELECT @V_CDFILIMOVI, @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @P_CDPRODUTO
          FROM PRODFILI
          WHERE CDFILIAL  = @V_CDFILIMOVI  AND
                CDPRODUTO = @P_CDPRODUTO AND
                ISNULL(IDCNTRESTOQ, 'S') <> 'N' AND
          NOT EXISTS
          (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO
           FROM PRODLCESTOQ
           WHERE CDFILIAL     = @V_CDFILIMOVI   AND
                 CDALMOXARIFE = @V_CDALMOXARIFE AND
                 CDLOCALESTOQ = @V_CDLOCALESTOQ AND
                 CDPRODUTO    = @P_CDPRODUTO));
      END;
   END
   ELSE BEGIN
      SET @V_IDCNTRESTOQ = 'N';
   END;

   IF (@V_IDCNTRESTOQ = 'S') AND (@V_IDSISTEMA = 'SEP') AND (@P_IDATUESTPROD = 'N')  BEGIN
      SET @V_IDCNTRESTOQ = 'N';
   END;

   IF (@V_IDCNTRESTOQ = 'S') AND (@V_IDENTRSAIDOP = 'S') BEGIN
      SET @V_QTITEMPROD = @P_QTITEMPROD;
      SET @V_QTSALDSAID = @P_QTITEMPROD;

      IF (@P_NRLOTEESTQ IS NULL) BEGIN

         SET @V_NRLOTEESTQ = ' ';
         SET @V_NRSUBLOTE  = ' ';

         SELECT @V_CDPRODESTO = MAX(CDPRODESTO)
         FROM PRODUTO
         WHERE CDPRODUTO = @P_CDPRODUTO;

         INSERT INTO LOTE
            (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE, DTENTRLOTE)
            (SELECT @V_CDFILIMOVI,  @V_NRLOTEESTQ, @V_NRSUBLOTE,
                    @V_CDPRODESTO, 'L' , GETDATE()
             FROM PARAMGERAL
             WHERE
             NOT EXISTS
             (SELECT CDFILIAL,      NRLOTEESTQ,  NRSUBLOTE,
                     @V_CDPRODESTO, 'L', GETDATE()
              FROM LOTE
              WHERE  @V_CDFILIMOVI  =  CDFILIAL     AND
                     @V_NRLOTEESTQ  =  NRLOTEESTQ   AND
                     @V_NRSUBLOTE   =  NRSUBLOTE    AND
                     @V_CDPRODESTO  =  CDPRODUTO));

         IF (@V_IDUTILLOTE = 'S') BEGIN
            IF (@V_IDESTGERALEXP = 'S') BEGIN
               DECLARE C_LOTEGERAL CURSOR FOR
               SELECT P.CDALMOXARIFE, P.CDLOCALESTOQ, L.NRLOTEESTQ, L.NRSUBLOTE, (P.QTTOTALESTOQ/@V_VRFATOCONV) AS QTTOTALESTOQ
                 FROM POSESTATU P, LOTE L
                WHERE (P.CDFILIAL     = @V_CDFILIMOVI)
                  AND (P.CDPRODUTO    = @V_CDPRODESTO)
                  AND (P.CDFILIAL     = L.CDFILIAL)
                  AND (P.CDPRODUTO    = L.CDPRODUTO)
                  AND (P.NRLOTEESTQ   = L.NRLOTEESTQ)
                  AND (P.NRSUBLOTE    = L.NRSUBLOTE)
                  AND (P.QTTOTALESTOQ > 0)
                  AND (ISNULL(L.DTVALILOTE, CONVERT( DATETIME, '30/12/9999', 103)) >= GETDATE())
               ORDER BY  ISNULL(L.DTVALILOTE, L.DTENTRLOTE), L.NRLOTEESTQ, L.NRSUBLOTE;

               OPEN C_LOTEGERAL;
               FETCH NEXT FROM C_LOTEGERAL INTO @V_LOTE_CDALMOXARIFE, @V_LOTE_CDLOCALESTOQ, @V_LOTE_NRLOTEESTQ, @V_LOTE_NRSUBLOTE, @V_LOTE_QTTOTALESTOQ;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SET @V_CDALMOXARIFE = @V_LOTE_CDALMOXARIFE;
                  SET @V_CDLOCALESTOQ = @V_LOTE_CDLOCALESTOQ;
                  SET @V_NRLOTEESTQ = @V_LOTE_NRLOTEESTQ;
                  SET @V_NRSUBLOTE  = @V_LOTE_NRSUBLOTE;

                  IF (@V_QTSALDSAID <= @V_LOTE_QTTOTALESTOQ) BEGIN
                     SET @V_QTITEMPROD = @V_QTSALDSAID;
                  END
                  ELSE BEGIN
                     SET @V_QTITEMPROD = @V_LOTE_QTTOTALESTOQ;
                  END;

                  SET @V_VRTOTAITEM = @V_VRUNITITEM * @V_QTITEMPROD;
                  SET @V_VRCONTITEM = @V_VRTOTAITEM;

                  IF @V_VRTOTPEDIDO > 0  BEGIN
                     SET @V_VRDESCITEM = (@P_VRDESCITEM * @V_VRTOTAITEM)/@V_VRTOTPEDIDO;
                  END
                  ELSE BEGIN
                     SET @V_VRDESCITEM = 0;
                  END;
                  IF @V_VRTOTAITEM > 0  BEGIN
                     SET @V_VRDESPERITEM = (@V_VRDESCITEM * 100)/@V_VRTOTAITEM;
                  END
                  ELSE BEGIN
                     SET @V_VRDESPERITEM = 0;
                  END;

                  IF (@V_QTSALDSAID > 0) BEGIN
                     IF (@V_IDSISTEMA = 'PDV') OR (@V_IDSISTEMA = 'VND') BEGIN
                        INSERT INTO ITEMPRODUTO
                           (CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,    CDPRODEMIS,
                            DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM,   VRDESCITEM,
                            VRTOTAITEM,   VRCONTITEM,   IDCONFORITEM, VRBRUTITEM,   CDFILIALPED,
                            NRPEDIDO,     NRITEMPED,    CDCSTINFUSU,  CDCFOPINFUSU, CDSUFXINFUSU,
                            CDFILIMOVI,   CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,   NRSUBLOTE,
                            CDFILIALVEND, NRSEQVENDA,   NRSEQUITVEND, VRDESPERITEM, QTVOLUITEM,
                            CDSERVFILI, CDFILIAPUR, CDMARCA, CDSERVFATU, NRPEDPROD, NRSEQPEDPROD, IDORIGEMPROD,
                            VRICMSSTITORIG)
                        VALUES
                           (@P_CDFILIAL,     @P_NRLANCTONF,   @V_NRSEQITPROD,  @P_CDPRODUTO,    @P_CDPRODEMIS,
                            @P_DSPRODEMIS,   @V_IDCNTRESTOQ,  @V_QTSALDSAID,   @V_VRUNITITEM,   @V_VRDESCITEM,
                            ROUND(@V_VRTOTAITEM,2,2), ROUND(@V_VRCONTITEM,2,2),   @P_IDCONFORITEM, ROUND(@V_VRCONTITEM,2,2),
                            @V_CDFILIALPED,  @V_NRPEDIDO,     @V_NRITEMPED,    @P_CDCSTINFUSU,  @P_CDCFOPINFUSU, @P_CDSUFXINFUSU,
                            @V_CDFILIMOVI,   @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,   @V_NRSUBLOTE,
                            @V_CDFILIALPDV,  @V_NRSEQVENDA,   @V_NRSEQUITVEND, @V_VRDESPERITEM, @P_QTVOLUITEM,
                            @P_CDSERVFILI, @P_CDFILIAPUR, @P_CDMARCA, @P_CDSERVFATU, @V_NRORDEMCMPPED, @V_NRITORDEMCMPPED,
                            @P_IDORIGEMPROD, @P_VRICMSSTITORIG);
                     END
                     ELSE BEGIN
                        INSERT INTO ITEMPRODUTO
                           (CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,    CDPRODEMIS,
                            DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM,   VRDESCITEM,
                            VRTOTAITEM,   VRCONTITEM,   IDCONFORITEM, VRBRUTITEM,   CDFILIALPED,
                            NRPEDIDO,     NRITEMPED,    CDCSTINFUSU,  CDCFOPINFUSU, CDSUFXINFUSU,
                            CDFILIMOVI,   CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,   NRSUBLOTE,
                            CDFILIALVEND, NRSEQVENDA,   NRSEQUITVEND, VRDESPERITEM, QTVOLUITEM,
                            CDSERVFILI, CDFILIAPUR, CDMARCA, CDSERVFATU, NRPEDPROD, NRSEQPEDPROD, IDORIGEMPROD,
                            VRICMSSTITORIG)
                        VALUES
                           (@P_CDFILIAL,     @P_NRLANCTONF,   @V_NRSEQITPROD,  @P_CDPRODUTO,    @P_CDPRODEMIS,
                            @P_DSPRODEMIS,   @V_IDCNTRESTOQ,  @V_QTSALDSAID,   @V_VRUNITITEM,   @V_VRDESCITEM,
                            ROUND(@V_VRTOTAITEM,2), ROUND(@V_VRCONTITEM,2),   @P_IDCONFORITEM, ROUND(@V_VRCONTITEM,2),
                            @V_CDFILIALPED,  @V_NRPEDIDO,     @V_NRITEMPED,    @P_CDCSTINFUSU,  @P_CDCFOPINFUSU, @P_CDSUFXINFUSU,
                            @V_CDFILIMOVI,   @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,   @V_NRSUBLOTE,
                            @V_CDFILIALPDV,  @V_NRSEQVENDA,   @V_NRSEQUITVEND, @V_VRDESPERITEM, @P_QTVOLUITEM,
                            @P_CDSERVFILI, @P_CDFILIAPUR, @P_CDMARCA, @P_CDSERVFATU, @V_NRORDEMCMPPED, @V_NRITORDEMCMPPED,
                            @P_IDORIGEMPROD, @P_VRICMSSTITORIG);
                     END;

                     IF (@V_QTSALDSAID <= @V_LOTE_QTTOTALESTOQ) BEGIN
                        SET @V_QTSALDSAID = 0;
                     END
                     ELSE BEGIN
                        SET @V_QTSALDSAID = @V_QTSALDSAID - @V_LOTE_QTTOTALESTOQ;
                     END;

                     SET @V_NRSEQITPROD = RIGHT(REPLICATE('0',4)+ CONVERT(VARCHAR, (CONVERT(NUMERIC, ISNULL(MAX(@V_NRSEQITPROD),'0000')) + 1)),4)

                     INSERT INTO @ARRAY_NRSEQITPROD VALUES (@V_NRSEQITPROD);
                  END;

                  FETCH NEXT FROM C_LOTEGERAL INTO @V_LOTE_CDALMOXARIFE, @V_LOTE_CDLOCALESTOQ, @V_LOTE_NRLOTEESTQ, @V_LOTE_NRSUBLOTE, @V_LOTE_QTTOTALESTOQ;
               END;
               CLOSE C_LOTEGERAL;
               DEALLOCATE C_LOTEGERAL;
            END
            ELSE BEGIN
            ----------------
               DECLARE C_LOTE CURSOR FOR
                  SELECT L.NRLOTEESTQ,   L.NRSUBLOTE,
                        (P.QTTOTALESTOQ/@V_VRFATOCONV) AS QTTOTALESTOQ,
                         P.VRTOTALESTOQ
                  FROM POSESTATU P, LOTE L
                  WHERE (L.CDFILIAL     = @V_CDFILIMOVI)   AND
                        (P.CDALMOXARIFE = @V_CDALMOXARIFE) AND
                        (P.CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
                        (P.CDPRODUTO    = @V_CDPRODESTO)   AND
                        (P.CDFILIAL     = L.CDFILIAL)      AND
                        (P.NRLOTEESTQ   = L.NRLOTEESTQ)    AND
                        (P.NRSUBLOTE    = L.NRSUBLOTE)     AND
                        (P.CDPRODUTO    = L.CDPRODUTO)     AND
                        (P.QTTOTALESTOQ > 0)               AND
                        (ISNULL(L.DTVALILOTE, CONVERT( DATETIME, '30/12/9999', 103)) >= GETDATE())
                  ORDER BY  ISNULL(L.DTVALILOTE, L.DTENTRLOTE), L.NRLOTEESTQ, L.NRSUBLOTE;

               OPEN C_LOTE;
               FETCH NEXT FROM C_LOTE INTO @V_LOTE_NRLOTEESTQ,   @V_LOTE_NRSUBLOTE,
                                           @V_LOTE_QTTOTALESTOQ, @V_LOTE_VRTOTALESTOQ;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SET @V_NRLOTEESTQ = @V_LOTE_NRLOTEESTQ;
                  SET @V_NRSUBLOTE  = @V_LOTE_NRSUBLOTE;

                  IF (@V_QTSALDSAID <= @V_LOTE_QTTOTALESTOQ) BEGIN
                     SET @V_QTITEMPROD = @V_QTSALDSAID;
                  END
                  ELSE BEGIN
                     SET @V_QTITEMPROD = @V_LOTE_QTTOTALESTOQ;
                  END;

                  SET @V_VRTOTAITEM = @V_VRUNITITEM * @V_QTITEMPROD;
                  SET @V_VRCONTITEM = @V_VRTOTAITEM;

                  IF @V_VRTOTPEDIDO > 0  BEGIN
                     SET @V_VRDESCITEM = (@P_VRDESCITEM * @V_VRTOTAITEM)/@V_VRTOTPEDIDO;
                  END
                  ELSE BEGIN
                     SET @V_VRDESCITEM = 0;
                  END;
                  IF @V_VRTOTAITEM > 0  BEGIN
                     SET @V_VRDESPERITEM = (@V_VRDESCITEM * 100)/@V_VRTOTAITEM;
                  END
                  ELSE BEGIN
                     SET @V_VRDESPERITEM = 0;
                  END;

                  IF (@V_QTSALDSAID > 0) BEGIN
                     IF (@V_IDSISTEMA = 'PDV') OR (@V_IDSISTEMA = 'VND') BEGIN
                        INSERT INTO ITEMPRODUTO
                           (CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,    CDPRODEMIS,
                            DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM,   VRDESCITEM,
                            VRTOTAITEM,   VRCONTITEM,   IDCONFORITEM, VRBRUTITEM,   CDFILIALPED,
                            NRPEDIDO,     NRITEMPED,    CDCSTINFUSU,  CDCFOPINFUSU, CDSUFXINFUSU,
                            CDFILIMOVI,   CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,   NRSUBLOTE,
                            CDFILIALVEND, NRSEQVENDA,   NRSEQUITVEND, VRDESPERITEM, QTVOLUITEM,
                            CDSERVFILI, CDFILIAPUR, CDMARCA, CDSERVFATU, NRPEDPROD, NRSEQPEDPROD, IDORIGEMPROD,
                            VRICMSSTITORIG)
                        VALUES
                           (@P_CDFILIAL,     @P_NRLANCTONF,   @V_NRSEQITPROD,  @P_CDPRODUTO,    @P_CDPRODEMIS,
                            @P_DSPRODEMIS,   @V_IDCNTRESTOQ,  @V_QTSALDSAID,   @V_VRUNITITEM,   @V_VRDESCITEM,
                            ROUND(@V_VRTOTAITEM,2,2), ROUND(@V_VRCONTITEM,2,2),   @P_IDCONFORITEM, ROUND(@V_VRCONTITEM,2,2),
                            @V_CDFILIALPED,  @V_NRPEDIDO,     @V_NRITEMPED,    @P_CDCSTINFUSU,  @P_CDCFOPINFUSU, @P_CDSUFXINFUSU,
                            @V_CDFILIMOVI,   @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,   @V_NRSUBLOTE,
                            @V_CDFILIALPDV,  @V_NRSEQVENDA,   @V_NRSEQUITVEND, @V_VRDESPERITEM, @P_QTVOLUITEM,
                            @P_CDSERVFILI, @P_CDFILIAPUR, @P_CDMARCA, @P_CDSERVFATU, @V_NRORDEMCMPPED, @V_NRITORDEMCMPPED,
                            @P_IDORIGEMPROD, @P_VRICMSSTITORIG);
                     END
                     ELSE BEGIN
                        INSERT INTO ITEMPRODUTO
                           (CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,    CDPRODEMIS,
                            DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM,   VRDESCITEM,
                            VRTOTAITEM,   VRCONTITEM,   IDCONFORITEM, VRBRUTITEM,   CDFILIALPED,
                            NRPEDIDO,     NRITEMPED,    CDCSTINFUSU,  CDCFOPINFUSU, CDSUFXINFUSU,
                            CDFILIMOVI,   CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,   NRSUBLOTE,
                            CDFILIALVEND, NRSEQVENDA,   NRSEQUITVEND, VRDESPERITEM, QTVOLUITEM,
                            CDSERVFILI, CDFILIAPUR, CDMARCA, CDSERVFATU, NRPEDPROD, NRSEQPEDPROD, IDORIGEMPROD,
                            VRICMSSTITORIG)
                        VALUES
                           (@P_CDFILIAL,     @P_NRLANCTONF,   @V_NRSEQITPROD,  @P_CDPRODUTO,    @P_CDPRODEMIS,
                            @P_DSPRODEMIS,   @V_IDCNTRESTOQ,  @V_QTSALDSAID,   @V_VRUNITITEM,   @V_VRDESCITEM,
                            ROUND(@V_VRTOTAITEM,2), ROUND(@V_VRCONTITEM,2),   @P_IDCONFORITEM, ROUND(@V_VRCONTITEM,2),
                            @V_CDFILIALPED,  @V_NRPEDIDO,     @V_NRITEMPED,    @P_CDCSTINFUSU,  @P_CDCFOPINFUSU, @P_CDSUFXINFUSU,
                            @V_CDFILIMOVI,   @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,   @V_NRSUBLOTE,
                            @V_CDFILIALPDV,  @V_NRSEQVENDA,   @V_NRSEQUITVEND, @V_VRDESPERITEM, @P_QTVOLUITEM,
                            @P_CDSERVFILI, @P_CDFILIAPUR, @P_CDMARCA, @P_CDSERVFATU, @V_NRORDEMCMPPED, @V_NRITORDEMCMPPED,
                            @P_IDORIGEMPROD, @P_VRICMSSTITORIG);
                     END;

                     IF (@V_QTSALDSAID <= @V_LOTE_QTTOTALESTOQ) BEGIN
                        SET @V_QTSALDSAID = 0;
                     END
                     ELSE BEGIN
                        SET @V_QTSALDSAID = @V_QTSALDSAID - @V_LOTE_QTTOTALESTOQ;
                     END;

                     SET @V_NRSEQITPROD = RIGHT(REPLICATE('0',4)+ CONVERT(VARCHAR, (CONVERT(NUMERIC, ISNULL(MAX(@V_NRSEQITPROD),'0000')) + 1)),4)

                     INSERT INTO @ARRAY_NRSEQITPROD VALUES (@V_NRSEQITPROD);
                  END;

                     FETCH NEXT FROM C_LOTE INTO @V_LOTE_NRLOTEESTQ,   @V_LOTE_NRSUBLOTE,
                                                 @V_LOTE_QTTOTALESTOQ, @V_LOTE_VRTOTALESTOQ;
               END;
               CLOSE C_LOTE;
               DEALLOCATE C_LOTE;
            END;
            IF (@V_QTSALDSAID > 0) BEGIN
               IF (@V_IDSISTEMA = 'PDV') OR (@V_IDSISTEMA = 'VND') BEGIN /* SOL.124659 */
                  SET @V_VRTOTAITEM = ROUND(@V_VRUNITITEM * @V_QTSALDSAID,2);
               END
               ELSE BEGIN
                  SET @V_VRTOTAITEM = @V_VRUNITITEM * @V_QTSALDSAID;
               END;

               SET @V_VRCONTITEM = @V_VRTOTAITEM;

               IF (@V_VRTOTPEDIDO > 0) BEGIN
                  SET @V_VRDESCITEM = (@P_VRDESCITEM * @V_VRTOTAITEM)/@V_VRTOTPEDIDO;
               END
               ELSE BEGIN
                  SET @V_VRDESCITEM   = 0;
               END;

               IF (@V_VRTOTAITEM > 0) BEGIN
                  SET @V_VRDESPERITEM = (@V_VRDESCITEM * 100)/@V_VRTOTAITEM;
               END
               ELSE BEGIN
                  SET @V_VRDESPERITEM = 0;
               END;

               IF (@V_VRTOTPEDIDO > 0) BEGIN
                  SET @V_VRICMSSTITORIG   = (@P_VRICMSSTITORIG * @V_VRTOTAITEM)/@V_VRTOTPEDIDO;
               END
               ELSE BEGIN
                  SET @V_VRICMSSTITORIG   = 0;
               END;

               IF (@V_IDSISTEMA = 'PDV') OR (@V_IDSISTEMA = 'VND') BEGIN
                   INSERT INTO ITEMPRODUTO
                     (CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,    CDPRODEMIS,
                      DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM,   VRDESCITEM,
                      VRTOTAITEM,   VRCONTITEM,   IDCONFORITEM, VRBRUTITEM,   CDFILIALPED,
                      NRPEDIDO,     NRITEMPED,    CDCSTINFUSU,  CDCFOPINFUSU, CDSUFXINFUSU,
                      CDFILIMOVI,   CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,   NRSUBLOTE,
                      CDFILIALVEND, NRSEQVENDA,   NRSEQUITVEND, VRDESPERITEM, QTVOLUITEM,
                      CDSERVFILI, CDFILIAPUR, CDMARCA, CDSERVFATU, NRPEDPROD, NRSEQPEDPROD, IDORIGEMPROD,
                      VRICMSSTITORIG)
                  VALUES
                     (@P_CDFILIAL,     @P_NRLANCTONF,   @V_NRSEQITPROD,  @P_CDPRODUTO,    @P_CDPRODEMIS,
                      @P_DSPRODEMIS,   @V_IDCNTRESTOQ,  @V_QTSALDSAID,   @V_VRUNITITEM,   @V_VRDESCITEM,
                      ROUND(@V_VRTOTAITEM,2,2),   ROUND(@V_VRCONTITEM,2,2), @P_IDCONFORITEM, ROUND(@V_VRCONTITEM,2,2),
                      @V_CDFILIALPED,  @V_NRPEDIDO,     @V_NRITEMPED,    @P_CDCSTINFUSU,  @P_CDCFOPINFUSU, @P_CDSUFXINFUSU,
                      @V_CDFILIMOVI,   @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,   @V_NRSUBLOTE,
                      @V_CDFILIALPDV,  @V_NRSEQVENDA,   @V_NRSEQUITVEND, @V_VRDESPERITEM, @P_QTVOLUITEM,
                      @P_CDSERVFILI, @P_CDFILIAPUR, @P_CDMARCA, @P_CDSERVFATU, @V_NRORDEMCMPPED, @V_NRITORDEMCMPPED,
                      @P_IDORIGEMPROD, @V_VRICMSSTITORIG);
               END
               ELSE BEGIN
                  INSERT INTO ITEMPRODUTO
                     (CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,    CDPRODEMIS,
                      DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM,   VRDESCITEM,
                      VRTOTAITEM,   VRCONTITEM,   IDCONFORITEM, VRBRUTITEM,   CDFILIALPED,
                      NRPEDIDO,     NRITEMPED,    CDCSTINFUSU,  CDCFOPINFUSU, CDSUFXINFUSU,
                      CDFILIMOVI,   CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,   NRSUBLOTE,
                      CDFILIALVEND, NRSEQVENDA,   NRSEQUITVEND, VRDESPERITEM, QTVOLUITEM,
                      CDSERVFILI, CDFILIAPUR, CDMARCA, CDSERVFATU, NRPEDPROD, NRSEQPEDPROD, IDORIGEMPROD,
                      VRICMSSTITORIG)
                  VALUES
                     (@P_CDFILIAL,     @P_NRLANCTONF,   @V_NRSEQITPROD,  @P_CDPRODUTO,    @P_CDPRODEMIS,
                      @P_DSPRODEMIS,   @V_IDCNTRESTOQ,  @V_QTSALDSAID,   @V_VRUNITITEM,   @V_VRDESCITEM,
                      ROUND(@V_VRTOTAITEM,2),   ROUND(@V_VRCONTITEM,2), @P_IDCONFORITEM, ROUND(@V_VRCONTITEM,2),
                      @V_CDFILIALPED,  @V_NRPEDIDO,     @V_NRITEMPED,    @P_CDCSTINFUSU,  @P_CDCFOPINFUSU, @P_CDSUFXINFUSU,
                      @V_CDFILIMOVI,   @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,   @V_NRSUBLOTE,
                      @V_CDFILIALPDV,  @V_NRSEQVENDA,   @V_NRSEQUITVEND, @V_VRDESPERITEM, @P_QTVOLUITEM,
                      @P_CDSERVFILI, @P_CDFILIAPUR, @P_CDMARCA, @P_CDSERVFATU, @V_NRORDEMCMPPED, @V_NRITORDEMCMPPED,
                      @P_IDORIGEMPROD, @V_VRICMSSTITORIG);
               END;

               SET @V_QTSALDSAID = 0;
            END;
         END
         ELSE BEGIN
           IF (@V_IDSISTEMA = 'PDV') OR (@V_IDSISTEMA = 'VND') BEGIN
              INSERT INTO ITEMPRODUTO
                  (CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,    CDPRODEMIS,
                   DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM,   VRDESCITEM,
                   VRTOTAITEM,   VRCONTITEM,   IDCONFORITEM, VRBRUTITEM,   CDFILIALPED,
                   NRPEDIDO,     NRITEMPED,    CDCSTINFUSU,  CDCFOPINFUSU, CDSUFXINFUSU,
                   CDFILIMOVI,   CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,   NRSUBLOTE,
                   CDFILIALVEND, NRSEQVENDA,   NRSEQUITVEND, VRDESPERITEM, QTVOLUITEM,
                   CDSERVFILI, CDFILIAPUR, CDMARCA, CDSERVFATU, NRPEDPROD, NRSEQPEDPROD, IDORIGEMPROD,
                   VRICMSSTITORIG)
               VALUES
                  (@P_CDFILIAL,     @P_NRLANCTONF,   @V_NRSEQITPROD,  @P_CDPRODUTO,    @P_CDPRODEMIS,
                   @P_DSPRODEMIS,   @V_IDCNTRESTOQ,  @V_QTITEMPROD,   @V_VRUNITITEM,   @P_VRDESCITEM,
                   ROUND(@V_VRTOTAITEM,2,2), ROUND(@V_VRCONTITEM,2,2),   @P_IDCONFORITEM, ROUND(@V_VRCONTITEM,2,2),
                   @V_CDFILIALPED,  @V_NRPEDIDO,     @V_NRITEMPED,    @P_CDCSTINFUSU,  @P_CDCFOPINFUSU, @P_CDSUFXINFUSU,
                   @V_CDFILIMOVI,   @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,   @V_NRSUBLOTE,
                   @V_CDFILIALPDV,  @V_NRSEQVENDA,   @V_NRSEQUITVEND, @V_VRDESPERITEM, @P_QTVOLUITEM,
                   @P_CDSERVFILI, @P_CDFILIAPUR, @P_CDMARCA, @P_CDSERVFATU, @V_NRORDEMCMPPED, @V_NRITORDEMCMPPED,
                   @P_IDORIGEMPROD, @P_VRICMSSTITORIG);
            END
            ELSE BEGIN
               INSERT INTO ITEMPRODUTO
                  (CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,    CDPRODEMIS,
                   DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM,   VRDESCITEM,
                   VRTOTAITEM,   VRCONTITEM,   IDCONFORITEM, VRBRUTITEM,   CDFILIALPED,
                   NRPEDIDO,     NRITEMPED,    CDCSTINFUSU,  CDCFOPINFUSU, CDSUFXINFUSU,
                   CDFILIMOVI,   CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,   NRSUBLOTE,
                   CDFILIALVEND, NRSEQVENDA,   NRSEQUITVEND, VRDESPERITEM, QTVOLUITEM,
                   CDSERVFILI, CDFILIAPUR, CDMARCA, CDSERVFATU, NRPEDPROD, NRSEQPEDPROD, IDORIGEMPROD,
                   VRICMSSTITORIG)
               VALUES
                  (@P_CDFILIAL,     @P_NRLANCTONF,   @V_NRSEQITPROD,  @P_CDPRODUTO,    @P_CDPRODEMIS,
                   @P_DSPRODEMIS,   @V_IDCNTRESTOQ,  @V_QTITEMPROD,   @V_VRUNITITEM,   @P_VRDESCITEM,
                   ROUND(@V_VRTOTAITEM,2), ROUND(@V_VRCONTITEM,2),   @P_IDCONFORITEM, ROUND(@V_VRCONTITEM,2),
                   @V_CDFILIALPED,  @V_NRPEDIDO,     @V_NRITEMPED,    @P_CDCSTINFUSU,  @P_CDCFOPINFUSU, @P_CDSUFXINFUSU,
                   @V_CDFILIMOVI,   @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,   @V_NRSUBLOTE,
                   @V_CDFILIALPDV,  @V_NRSEQVENDA,   @V_NRSEQUITVEND, @V_VRDESPERITEM, @P_QTVOLUITEM,
                   @P_CDSERVFILI, @P_CDFILIAPUR, @P_CDMARCA, @P_CDSERVFATU, @V_NRORDEMCMPPED, @V_NRITORDEMCMPPED,
                   @P_IDORIGEMPROD, @P_VRICMSSTITORIG);
            END;
         END;
      END
      ELSE BEGIN
         SET @V_NRLOTEESTQ = @P_NRLOTEESTQ;
         SET @V_NRSUBLOTE  = @P_NRSUBLOTE;
         IF @V_NRSUBLOTE IS NULL BEGIN
            SET @V_NRSUBLOTE = ' ';
         END;

         SELECT @V_CDPRODESTO = MAX(CDPRODESTO)
         FROM PRODUTO
         WHERE CDPRODUTO = @P_CDPRODUTO;

         INSERT INTO LOTE
            (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE, DTENTRLOTE)
            (SELECT @V_CDFILIMOVI,  @V_NRLOTEESTQ, @V_NRSUBLOTE,
                    @V_CDPRODESTO, 'L' , GETDATE()
             FROM PARAMGERAL
             WHERE
             NOT EXISTS
             (SELECT CDFILIAL,      NRLOTEESTQ,  NRSUBLOTE,
                     @V_CDPRODESTO, 'L', GETDATE()
              FROM LOTE
              WHERE  @V_CDFILIMOVI  =  CDFILIAL     AND
                     @V_NRLOTEESTQ  =  NRLOTEESTQ   AND
                     @V_NRSUBLOTE   =  NRSUBLOTE    AND
                     @V_CDPRODESTO  =  CDPRODUTO));

         IF (@V_CDTPOPERPERDA IS NOT NULL) OR (@V_CDTPOPERSOBRA IS NOT NULL) BEGIN
            IF (@V_CDTPOPERPERDA = @V_CDTIPOOPER) BEGIN
               SET @V_NRLOTEESTQORIG = @V_NRLOTEESTQ;
               SET @V_NRSUBLOTEORIG = @V_NRSUBLOTE;
               SET @V_NRLOTEESTQ = ' ';
               SET @V_NRSUBLOTE = ' ';
            END;
            IF (@V_CDTPOPERSOBRA = @V_CDTIPOOPER) BEGIN
               SET @V_NRLOTEESTQORIG = @V_NRLOTEESTQ;
               SET @V_NRSUBLOTEORIG  = @V_NRSUBLOTE;
            END;
         END;

         IF (@V_IDSISTEMA = 'PDV') OR (@V_IDSISTEMA = 'VND') BEGIN
            INSERT INTO ITEMPRODUTO
               (CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,    CDPRODEMIS,
                DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM,   VRDESCITEM,
                VRTOTAITEM,   VRCONTITEM,   IDCONFORITEM, VRBRUTITEM,   CDFILIALPED,
                NRPEDIDO,     NRITEMPED,    CDCSTINFUSU,  CDCFOPINFUSU, CDSUFXINFUSU,
                CDFILIMOVI,   CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,   NRSUBLOTE,
                CDFILIALVEND, NRSEQVENDA,   NRSEQUITVEND, VRDESPERITEM, QTVOLUITEM,
                CDSERVFILI, CDFILIAPUR, CDMARCA, CDSERVFATU, NRPEDPROD, NRSEQPEDPROD, IDORIGEMPROD,
                VRICMSSTITORIG, NRLOTEESTQORIG, NRSUBLOTEORIG)
            VALUES
               (@P_CDFILIAL,     @P_NRLANCTONF,   @V_NRSEQITPROD,  @P_CDPRODUTO,    @P_CDPRODEMIS,
                @P_DSPRODEMIS,   @V_IDCNTRESTOQ,  @P_QTITEMPROD,   @V_VRUNITITEM,   @P_VRDESCITEM,
                ROUND(@V_VRTOTAITEM,2,2), ROUND(@V_VRCONTITEM,2,2),   @P_IDCONFORITEM, ROUND(@V_VRCONTITEM,2,2),
                @V_CDFILIALPED,  @V_NRPEDIDO,     @V_NRITEMPED,    @P_CDCSTINFUSU,  @P_CDCFOPINFUSU, @P_CDSUFXINFUSU,
                @V_CDFILIMOVI,   @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,   @V_NRSUBLOTE,
                @V_CDFILIALPDV,  @V_NRSEQVENDA,   @V_NRSEQUITVEND, @V_VRDESPERITEM, @P_QTVOLUITEM,
                @P_CDSERVFILI, @P_CDFILIAPUR, @P_CDMARCA, @P_CDSERVFATU, @V_NRORDEMCMPPED, @V_NRITORDEMCMPPED,
                @P_IDORIGEMPROD, @P_VRICMSSTITORIG, @V_NRLOTEESTQORIG, @V_NRSUBLOTEORIG);
         END
         ELSE BEGIN
            INSERT INTO ITEMPRODUTO
               (CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,    CDPRODEMIS,
                DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM,   VRDESCITEM,
                VRTOTAITEM,   VRCONTITEM,   IDCONFORITEM, VRBRUTITEM,   CDFILIALPED,
                NRPEDIDO,     NRITEMPED,    CDCSTINFUSU,  CDCFOPINFUSU, CDSUFXINFUSU,
                CDFILIMOVI,   CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,   NRSUBLOTE,
                CDFILIALVEND, NRSEQVENDA,   NRSEQUITVEND, VRDESPERITEM, QTVOLUITEM,
                CDSERVFILI, CDFILIAPUR, CDMARCA, CDSERVFATU, NRPEDPROD, NRSEQPEDPROD, IDORIGEMPROD,
                VRICMSSTITORIG, NRLOTEESTQORIG, NRSUBLOTEORIG)
            VALUES
               (@P_CDFILIAL,     @P_NRLANCTONF,   @V_NRSEQITPROD,  @P_CDPRODUTO,    @P_CDPRODEMIS,
                @P_DSPRODEMIS,   @V_IDCNTRESTOQ,  @P_QTITEMPROD,   @V_VRUNITITEM,   @P_VRDESCITEM,
                ROUND(@V_VRTOTAITEM,2), ROUND(@V_VRCONTITEM,2),   @P_IDCONFORITEM, ROUND(@V_VRCONTITEM,2),
                @V_CDFILIALPED,  @V_NRPEDIDO,     @V_NRITEMPED,    @P_CDCSTINFUSU,  @P_CDCFOPINFUSU, @P_CDSUFXINFUSU,
                @V_CDFILIMOVI,   @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,   @V_NRSUBLOTE,
                @V_CDFILIALPDV,  @V_NRSEQVENDA,   @V_NRSEQUITVEND, @V_VRDESPERITEM, @P_QTVOLUITEM,
                @P_CDSERVFILI, @P_CDFILIAPUR, @P_CDMARCA, @P_CDSERVFATU, @V_NRORDEMCMPPED, @V_NRITORDEMCMPPED,
                @P_IDORIGEMPROD, @P_VRICMSSTITORIG, @V_NRLOTEESTQORIG, @V_NRSUBLOTEORIG);
         END;
      END;
   END
   ELSE IF ((@V_IDCNTRESTOQ = 'S') AND (@V_IDENTRSAIDOP = 'E')) BEGIN

       SET @V_QTITEMPROD = @P_QTITEMPROD;

      IF (@P_NRLOTEESTQ IS NULL) BEGIN
         SET @V_NRLOTEESTQ = ' ';
         SET @V_NRSUBLOTE  = ' ';
      END
      ELSE BEGIN
         SET @V_NRLOTEESTQ = @P_NRLOTEESTQ;
         SET @V_NRSUBLOTE  = @P_NRSUBLOTE;
         IF @V_NRSUBLOTE IS NULL BEGIN
            SET @V_NRSUBLOTE = ' ';
         END;
      END;

      IF (@V_IDSISTEMA = 'PDV') OR (@V_IDSISTEMA = 'VND') BEGIN
         INSERT INTO ITEMPRODUTO
            (CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,    CDPRODEMIS,
             DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM,   VRDESCITEM,
             VRTOTAITEM,   VRCONTITEM,   IDCONFORITEM, VRBRUTITEM,   CDFILIALPED,
             NRPEDIDO,     NRITEMPED,    CDCSTINFUSU,  CDCFOPINFUSU, CDSUFXINFUSU,
             CDFILIMOVI,   CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,   NRSUBLOTE,
             VRDESPERITEM, QTVOLUITEM, CDSERVFILI, CDFILIAPUR, CDMARCA, CDSERVFATU, IDORIGEMPROD,
             VRICMSSTITORIG)
         VALUES
            (@P_CDFILIAL,     @P_NRLANCTONF,   @V_NRSEQITPROD,  @P_CDPRODUTO,       @P_CDPRODEMIS,
             @P_DSPRODEMIS,   @V_IDCNTRESTOQ,  @V_QTITEMPROD,   @V_VRUNITITEM,      @P_VRDESCITEM,
             ROUND(@V_VRTOTAITEM,2,2), ROUND(@V_VRCONTITEM,2,2),   @P_IDCONFORITEM,    ROUND(@V_VRCONTITEM,2,2),
             @V_CDFILIALPED,  @V_NRPEDIDO,     @V_NRITEMPED,    @P_CDCSTINFUSU,  @P_CDCFOPINFUSU,    @P_CDSUFXINFUSU,
             @V_CDFILIMOVI,   @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,      @V_NRSUBLOTE,
             @V_VRDESPERITEM, @P_QTVOLUITEM, @P_CDSERVFILI, @P_CDFILIAPUR, @P_CDMARCA, @P_CDSERVFATU,
             @P_IDORIGEMPROD, @P_VRICMSSTITORIG);
      END
      ELSE BEGIN
         INSERT INTO ITEMPRODUTO
            (CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,    CDPRODEMIS,
             DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM,   VRDESCITEM,
             VRTOTAITEM,   VRCONTITEM,   IDCONFORITEM, VRBRUTITEM,   CDFILIALPED,
             NRPEDIDO,     NRITEMPED,    CDCSTINFUSU,  CDCFOPINFUSU, CDSUFXINFUSU,
             CDFILIMOVI,   CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,   NRSUBLOTE,
             VRDESPERITEM, QTVOLUITEM, CDSERVFILI, CDFILIAPUR, CDMARCA, CDSERVFATU, IDORIGEMPROD,
             VRICMSSTITORIG)
         VALUES
            (@P_CDFILIAL,     @P_NRLANCTONF,   @V_NRSEQITPROD,  @P_CDPRODUTO,       @P_CDPRODEMIS,
             @P_DSPRODEMIS,   @V_IDCNTRESTOQ,  @V_QTITEMPROD,   @V_VRUNITITEM,      @P_VRDESCITEM,
             ROUND(@V_VRTOTAITEM,2), ROUND(@V_VRCONTITEM,2),   @P_IDCONFORITEM,    ROUND(@V_VRCONTITEM,2),
             @V_CDFILIALPED,  @V_NRPEDIDO,     @V_NRITEMPED,    @P_CDCSTINFUSU,  @P_CDCFOPINFUSU,    @P_CDSUFXINFUSU,
             @V_CDFILIMOVI,   @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,      @V_NRSUBLOTE,
             @V_VRDESPERITEM, @P_QTVOLUITEM, @P_CDSERVFILI, @P_CDFILIAPUR, @P_CDMARCA, @P_CDSERVFATU,
             @P_IDORIGEMPROD, @P_VRICMSSTITORIG);
      END;
   END
   ELSE BEGIN
      IF (@V_IDSISTEMA = 'PDV') OR (@V_IDSISTEMA = 'VND') BEGIN
         INSERT INTO ITEMPRODUTO
            (CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,    CDPRODEMIS,
             DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM,   VRDESCITEM,
             VRTOTAITEM,   VRCONTITEM,   IDCONFORITEM, VRBRUTITEM,   CDFILIALPED,
             NRPEDIDO,     NRITEMPED,    CDCSTINFUSU,  CDCFOPINFUSU, CDSUFXINFUSU,
             CDFILIALVEND, NRSEQVENDA,   NRSEQUITVEND, VRDESPERITEM, IDTPNFCREDEB,
             QTVOLUITEM, CDSERVFILI, CDFILIAPUR, CDMARCA, CDSERVFATU, IDORIGEMPROD,
             VRICMSSTITORIG)
         VALUES
            (@P_CDFILIAL,     @P_NRLANCTONF,   @V_NRSEQITPROD,  @P_CDPRODUTO,    @P_CDPRODEMIS,
             @P_DSPRODEMIS,   @V_IDCNTRESTOQ,  @P_QTITEMPROD,   @V_VRUNITITEM,   @P_VRDESCITEM,
             ROUND(@V_VRTOTAITEM,2,2), ROUND(@V_VRCONTITEM,2,2),   @P_IDCONFORITEM, ROUND(@V_VRCONTITEM,2,2),
             @V_CDFILIALPED,  @V_NRPEDIDO,     @V_NRITEMPED,    @P_CDCSTINFUSU,  @P_CDCFOPINFUSU, @P_CDSUFXINFUSU,
             @V_CDFILIALPDV,  @V_NRSEQVENDA,   @V_NRSEQUITVEND, @V_VRDESPERITEM, @P_IDTPNFCREDEB,
             @P_QTVOLUITEM, @P_CDSERVFILI, @P_CDFILIAPUR, @P_CDMARCA, @P_CDSERVFATU, @P_IDORIGEMPROD,
             @P_VRICMSSTITORIG);
      END
      ELSE BEGIN
         IF (@V_IDSISTEMA = 'SEP') BEGIN
            INSERT INTO ITEMPRODUTO
               (CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,    CDPRODEMIS,
                DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM,   VRDESCITEM,
                VRTOTAITEM,   VRCONTITEM,   IDCONFORITEM, VRBRUTITEM,   CDFILIALPED,
                NRPEDIDO,     NRITEMPED,    CDCSTINFUSU,  CDCFOPINFUSU, CDSUFXINFUSU,
                CDFILIMOVI,   CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,   NRSUBLOTE,
                VRDESPERITEM, QTVOLUITEM, CDSERVFILI, CDFILIAPUR, CDMARCA, CDSERVFATU, IDORIGEMPROD,
                VRICMSSTITORIG)
            VALUES
               (@P_CDFILIAL,     @P_NRLANCTONF,   @V_NRSEQITPROD,  @P_CDPRODUTO,       @P_CDPRODEMIS,
                @P_DSPRODEMIS,   @V_IDCNTRESTOQ,  @P_QTITEMPROD,   @V_VRUNITITEM,      @P_VRDESCITEM,
                ROUND(@V_VRTOTAITEM,2), ROUND(@V_VRCONTITEM,2),   @P_IDCONFORITEM,    ROUND(@V_VRCONTITEM,2),
                @V_CDFILIALPED,  @V_NRPEDIDO,     @V_NRITEMPED,    @P_CDCSTINFUSU,  @P_CDCFOPINFUSU,    @P_CDSUFXINFUSU,
                @V_CDFILIMOVI,   @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,      @V_NRSUBLOTE,
                @V_VRDESPERITEM, @P_QTVOLUITEM, @P_CDSERVFILI, @P_CDFILIAPUR, @P_CDMARCA, @P_CDSERVFATU,
                @P_IDORIGEMPROD, @P_VRICMSSTITORIG);
         END
         ELSE BEGIN
            INSERT INTO ITEMPRODUTO
               (CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,    CDPRODEMIS,
                DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM,   VRDESCITEM,
                VRTOTAITEM,   VRCONTITEM,   IDCONFORITEM, VRBRUTITEM,   CDFILIALPED,
                NRPEDIDO,     NRITEMPED,    CDCSTINFUSU,  CDCFOPINFUSU, CDSUFXINFUSU,
                CDFILIALVEND, NRSEQVENDA,   NRSEQUITVEND, VRDESPERITEM, IDTPNFCREDEB,
                QTVOLUITEM, CDSERVFILI, CDFILIAPUR, CDMARCA, CDSERVFATU, IDORIGEMPROD,
                VRICMSSTITORIG)
            VALUES
               (@P_CDFILIAL,     @P_NRLANCTONF,   @V_NRSEQITPROD,  @P_CDPRODUTO,    @P_CDPRODEMIS,
                @P_DSPRODEMIS,   @V_IDCNTRESTOQ,  @P_QTITEMPROD,   @V_VRUNITITEM,   @P_VRDESCITEM,
                ROUND(@V_VRTOTAITEM,2), ROUND(@V_VRCONTITEM,2),   @P_IDCONFORITEM, ROUND(@V_VRCONTITEM,2),
                @V_CDFILIALPED,  @V_NRPEDIDO,     @V_NRITEMPED,    @P_CDCSTINFUSU,  @P_CDCFOPINFUSU, @P_CDSUFXINFUSU,
                @V_CDFILIALPDV,  @V_NRSEQVENDA,   @V_NRSEQUITVEND, @V_VRDESPERITEM, @P_IDTPNFCREDEB,
                @P_QTVOLUITEM, @P_CDSERVFILI, @P_CDFILIAPUR, @P_CDMARCA, @P_CDSERVFATU, @P_IDORIGEMPROD,
                @P_VRICMSSTITORIG);
         END;       
      END;
   END;
   SET @V_NOTAFORNECEDOR = NULL;
   SET @V_LOTEFORNECEDOR = NULL;
   SET @V_TEXTOADICEMIS = NULL;
   SELECT @V_IDINFLOTFOREMI = ISNULL(IDINFLOTFOREMI, 'N')
     FROM PARAMFILIAL
    WHERE CDFILIAL = @V_CDFILIMOVI;
   IF @V_IDINFLOTFOREMI = 'S' BEGIN
      DECLARE C_ARRAY_NRSEQITPROD CURSOR  FOR SELECT NRSEQITPROD 
                                              FROM @ARRAY_NRSEQITPROD;
      OPEN C_ARRAY_NRSEQITPROD;
      FETCH NEXT FROM C_ARRAY_NRSEQITPROD INTO @C_ARRAY_NRSEQITPROD_NRSEQITPROD;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         SELECT @V_NRLOTEDADOFOR = ISNULL(NRLOTEESTQ, ' '),
                @V_NRSUBLOTEDADOFOR = ISNULL(NRSUBLOTE, ' ')
           FROM ITEMPRODUTO
          WHERE CDFILIAL = @P_CDFILIAL
            AND NRLANCTONF = @P_NRLANCTONF
            AND NRSEQITPROD = @C_ARRAY_NRSEQITPROD_NRSEQITPROD;
         
         IF (@V_NRLOTEDADOFOR IS NOT NULL) OR (@V_NRSUBLOTEDADOFOR IS NOT NULL) BEGIN
            IF (@V_CDTPOPERSOBRA IS NOT NULL) OR (@V_CDTPOPERPERDA IS NOT NULL) BEGIN
               SELECT @V_NOTAFORNECEDOR = MIN(NRNOTAFISC)
                 FROM ITEMPRODUTO I, NOTAFISCAL N
                WHERE CDFILIMOVI = @V_CDFILIMOVI
                  AND ISNULL(NRLOTEESTQORIG, NRLOTEESTQ) = @V_NRLOTEDADOFOR
                  AND ISNULL(NRSUBLOTEORIG, NRSUBLOTE) = @V_NRSUBLOTEDADOFOR
                  AND CDPRODUTO = @P_CDPRODUTO
                  AND N.CDFILIAL = I.CDFILIAL
                  AND N.NRLANCTONF = I.NRLANCTONF
                  AND N.IDENTRSAIDOP = 'E'
                  AND N.CDFORNECED IS NOT NULL;
            END;
            
            SELECT @V_LOTEFORNECEDOR = NRLOTEFORN
              FROM LOTE
             WHERE CDFILIAL = @V_CDFILIMOVI
               AND NRLOTEESTQ = @V_NRLOTEDADOFOR
               AND NRSUBLOTE = @V_NRSUBLOTEDADOFOR
               AND CDPRODUTO = @P_CDPRODUTO;
   
            IF @V_LOTEFORNECEDOR IS NOT NULL BEGIN
               SET @V_TEXTOADICEMIS = 'LT: ' + @V_LOTEFORNECEDOR;
               IF @V_NOTAFORNECEDOR IS NOT NULL BEGIN
                  SET @V_TEXTOADICEMIS = @V_TEXTOADICEMIS + ' - NF: ' + @V_NOTAFORNECEDOR;
               END;
            END ELSE BEGIN
               IF @V_NOTAFORNECEDOR IS NOT NULL BEGIN
                  SET @V_TEXTOADICEMIS = 'NF: ' + @V_NOTAFORNECEDOR;
               END;
            END;
   
            IF @V_TEXTOADICEMIS IS NOT NULL BEGIN
               UPDATE ITEMPRODUTO
                  SET DSPRODEMIS = DSPRODEMIS + ' - ' + @V_TEXTOADICEMIS
                WHERE CDFILIAL = @P_CDFILIAL
                  AND NRLANCTONF = @P_NRLANCTONF
                  AND NRSEQITPROD = @C_ARRAY_NRSEQITPROD_NRSEQITPROD;
            END;
         END;
         FETCH NEXT FROM C_ARRAY_NRSEQITPROD INTO @C_ARRAY_NRSEQITPROD_NRSEQITPROD;
      END;
      CLOSE C_ARRAY_NRSEQITPROD;
      DEALLOCATE C_ARRAY_NRSEQITPROD;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_NOTAFISCAL_PRODUTO','6.45.043';
GO

